/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

/*
 * ColorOptionsFrame.java
 *
 * Created on Apr 26, 2012, 9:57:23 AM
 */

package monalisa.addons.netviewer;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import monalisa.addons.util.MyWindowListener;
import monalisa.resources.ResourceManager;
import monalisa.resources.StringResources;

/**
 *
 * @author Jens Einloft
 */
public class ColorOptionsFrame extends javax.swing.JFrame {
    private static final long serialVersionUID = 8653637787349905596L;

    /** Creates new form ColorOptionsFrame */
    public ColorOptionsFrame(NetViewer netViewer) {
        this.netViewer = netViewer;
        initComponents();
        invColorSelectionLabel.addMouseListener(new MyColorOptionsMouseListener(invColorSelectionLabel));
        mctsColorSelectionLabel.addMouseListener(new MyColorOptionsMouseListener(mctsColorSelectionLabel));
        heatMapColorSelectionLabel.addMouseListener(new MyColorOptionsMouseListener(heatMapColorSelectionLabel));
        knockedOutColorSelectionLabel.addMouseListener(new MyColorOptionsMouseListener(knockedOutColorSelectionLabel));
        alsoKnockedOutColorSelectionLabel.addMouseListener(new MyColorOptionsMouseListener(alsoKnockedOutColorSelectionLabel));
        notKnockedOutColorSelectionLabel.addMouseListener(new MyColorOptionsMouseListener(notKnockedOutColorSelectionLabel));
        backgroundColorSelectionLabel.addMouseListener(new MyColorOptionsMouseListener(backgroundColorSelectionLabel));
        addWindowListener(new MyWindowListener(this.netViewer));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        mainPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        heatMapColorSelectionLabel = new javax.swing.JLabel();
        mctsColorSelectionLabel = new javax.swing.JLabel();
        invColorSelectionLabel = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        alsoKnockedOutColorSelectionLabel = new javax.swing.JLabel();
        knockedOutColorSelectionLabel = new javax.swing.JLabel();
        notKnockedOutColorSelectionLabel = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        jLabel15 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        backgroundColorSelectionLabel = new javax.swing.JLabel();
        saveButton = new javax.swing.JButton();

        setTitle("Color options");
        setIconImage(resources.getImage("icon-16.png"));

        mainPanel.setPreferredSize(new java.awt.Dimension(295, 345));

        jLabel1.setFont(new java.awt.Font("Cantarell", 1, 14)); // NOI18N
        jLabel1.setText("Analysis");

        jLabel2.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        jLabel2.setText("Invariants");

        jLabel3.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        jLabel3.setText("MCTS");

        jLabel4.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        jLabel4.setText("Heat maps");

        heatMapColorSelectionLabel.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        heatMapColorSelectionLabel.setText(strings.get("NVColorLabelDummy"));
        heatMapColorSelectionLabel.setOpaque(true);

        mctsColorSelectionLabel.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        mctsColorSelectionLabel.setText(strings.get("NVColorLabelDummy"));
        mctsColorSelectionLabel.setOpaque(true);

        invColorSelectionLabel.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        invColorSelectionLabel.setText(strings.get("NVColorLabelDummy"));
        invColorSelectionLabel.setOpaque(true);

        jLabel8.setFont(new java.awt.Font("Cantarell", 1, 14)); // NOI18N
        jLabel8.setText("Knockout Analysis");

        jLabel9.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        jLabel9.setText("K.O. Reaction");

        jLabel10.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        jLabel10.setText("also K.O. Reactions");

        jLabel11.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        jLabel11.setText("not K.O. Reaction");

        alsoKnockedOutColorSelectionLabel.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        alsoKnockedOutColorSelectionLabel.setText(strings.get("NVColorLabelDummy"));
        alsoKnockedOutColorSelectionLabel.setOpaque(true);

        knockedOutColorSelectionLabel.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        knockedOutColorSelectionLabel.setText(strings.get("NVColorLabelDummy"));
        knockedOutColorSelectionLabel.setOpaque(true);

        notKnockedOutColorSelectionLabel.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        notKnockedOutColorSelectionLabel.setText(strings.get("NVColorLabelDummy"));
        notKnockedOutColorSelectionLabel.setOpaque(true);

        jLabel15.setFont(new java.awt.Font("Cantarell", 1, 14)); // NOI18N
        jLabel15.setText("Other");

        jLabel16.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        jLabel16.setText("Background color");

        backgroundColorSelectionLabel.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        backgroundColorSelectionLabel.setText(strings.get("NVColorLabelDummy"));
        backgroundColorSelectionLabel.setOpaque(true);

        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addGroup(mainPanelLayout.createSequentialGroup()
                        .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel4)
                            .addComponent(jLabel3)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(invColorSelectionLabel)
                            .addComponent(mctsColorSelectionLabel)
                            .addComponent(heatMapColorSelectionLabel))))
                .addContainerGap(103, Short.MAX_VALUE))
            .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 298, Short.MAX_VALUE)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel8)
                .addContainerGap(141, Short.MAX_VALUE))
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel10)
                    .addComponent(jLabel9)
                    .addComponent(jLabel11))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(notKnockedOutColorSelectionLabel)
                    .addComponent(knockedOutColorSelectionLabel)
                    .addComponent(alsoKnockedOutColorSelectionLabel))
                .addContainerGap(44, Short.MAX_VALUE))
            .addComponent(jSeparator2, javax.swing.GroupLayout.DEFAULT_SIZE, 298, Short.MAX_VALUE)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel15)
                .addContainerGap(241, Short.MAX_VALUE))
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel16)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(backgroundColorSelectionLabel)
                .addContainerGap(55, Short.MAX_VALUE))
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addGap(114, 114, 114)
                .addComponent(saveButton)
                .addContainerGap(136, Short.MAX_VALUE))
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(invColorSelectionLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(mctsColorSelectionLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(heatMapColorSelectionLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(knockedOutColorSelectionLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel10)
                    .addComponent(alsoKnockedOutColorSelectionLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(notKnockedOutColorSelectionLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel15)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel16)
                    .addComponent(backgroundColorSelectionLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 38, Short.MAX_VALUE)
                .addComponent(saveButton)
                .addContainerGap())
        );

        jScrollPane1.setViewportView(mainPanel);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 350, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        try {
            this.netViewer.saveColorOptions();
        } catch (FileNotFoundException ex) {
            Logger.getLogger(ColorOptionsFrame.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(ColorOptionsFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_saveButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JLabel alsoKnockedOutColorSelectionLabel;
    protected javax.swing.JLabel backgroundColorSelectionLabel;
    protected javax.swing.JLabel heatMapColorSelectionLabel;
    protected javax.swing.JLabel invColorSelectionLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    protected javax.swing.JLabel knockedOutColorSelectionLabel;
    protected javax.swing.JPanel mainPanel;
    protected javax.swing.JLabel mctsColorSelectionLabel;
    protected javax.swing.JLabel notKnockedOutColorSelectionLabel;
    private javax.swing.JButton saveButton;
    // End of variables declaration//GEN-END:variables

    private static final ResourceManager resources = ResourceManager.instance();
    private static final StringResources strings = resources.getDefaultStrings();

    private NetViewer netViewer;

}
