/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

package monalisa.addons.netviewer;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

/**
 * MouseListener to react on mouse clicks for creating new nodes
 * @author Jens Einloft
 */
public class MyMouseListener implements MouseListener {
    private static final String NORMAL = "NORMAL";
    private static final String PLACE = "PLACE";
    private static final String TRANSITION = "TRANSITION";

    private String mouseMode = NORMAL;

    private NetViewer nv;

    public MyMouseListener(NetViewer nv) {
        this.nv = nv;
    }

    public void mouseClicked(MouseEvent e) {
        if(this.mouseMode.equalsIgnoreCase(PLACE))
            nv.createNewNode(NetViewer.PLACE, e.getX(), e.getY());
        else if(this.mouseMode.equalsIgnoreCase(TRANSITION))
            nv.createNewNode(NetViewer.TRANSITION, e.getX(), e.getY());
    }

    public void mousePressed(MouseEvent e) {

    }

    public void mouseReleased(MouseEvent e) {

    }

    public void mouseEntered(MouseEvent e) {

    }

    public void mouseExited(MouseEvent e) {

    }

    public void setMouseModeToPlace() {
        this.mouseMode = PLACE;
    }

    public void setMouseModeToTransition() {
        this.mouseMode = TRANSITION;
    }

    public void setMouseModeToNormal() {
        this.mouseMode = NORMAL;
    }

}
