/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */
package monalisa.addons.netviewer;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Map;
import javax.swing.JTextField;

/**
 * KeyListener for the search field in the SearchBar
 * @author Jens Einloft
 */
public class SearchFieldKeyListener implements KeyListener {

    private Map<String, NetViewerNode> name2Node;
    private JTextField owner;
    private NetViewer nv;

    public SearchFieldKeyListener(NetViewer nv, JTextField owner) {
        this.owner = owner;
        this.nv = nv;
        this.name2Node = nv.name2Node;
    }

    public void keyReleased(KeyEvent ke) {
        Collection<NetViewerNode> toShow = new ArrayList<NetViewerNode>();
        
        if(owner.getText().isEmpty()) {            
            toShow = new ArrayList(this.name2Node.values());          
        } else {
            // Check every name for match
            for(String s : this.name2Node.keySet()) {
                if(s.toLowerCase().contains(owner.getText().toLowerCase()))
                    toShow.add(name2Node.get(s));
            }            
        }            
        
        nv.updateSearchBar(toShow);
    }

    public void keyTyped(KeyEvent ke) { }

    public void keyPressed(KeyEvent ke) { }

}
