/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

package monalisa.addons.netviewer;

import java.awt.Color;
import java.awt.Paint;
import org.apache.commons.collections15.Transformer;

/**
 * Fill color of vertices
 * @author Jens Einloft
 */

public class VertexPaintTransformer implements Transformer<NetViewerNode, Paint>{

    private static final Color transparent = new Color(0,0,0,0);
    private Boolean hideColor = false;

    public Paint transform(NetViewerNode n) {
        if(hideColor) {
            Color color;            
            if(n.getNodeType().equalsIgnoreCase(NetViewer.TRANSITION))
                color = Color.BLACK;
            else if(n.getNodeType().equalsIgnoreCase(NetViewer.PLACE)) {
                if(n.isMasterNode())
                    color = Color.GRAY;
                else if (n.isLogical())
                    color = Color.LIGHT_GRAY;
                else
                    color = Color.WHITE;
            }
            else if(n.getNodeType().equalsIgnoreCase(NetViewer.BEND))
                color = transparent;
            else
                color = Color.BLACK;

            return color;
        }
        else
            return n.getColor();
    }

    public Boolean getHideColor() {
        return this.hideColor;
    }

    public void setHideColor(Boolean b) {
        this.hideColor = b;
    }

}
